mergetool--lib: Fix typo in the merge/difftool help
[git/jrn.git] / git-merge-one-file.sh
blob07dfeb8df4bf910c5c79fb4c3dd3345ba4719da0
1 #!/bin/sh
3 # Copyright (c) Linus Torvalds, 2005
5 # This is the git per-file merge script, called with
7 # $1 - original file SHA1 (or empty)
8 # $2 - file in branch1 SHA1 (or empty)
9 # $3 - file in branch2 SHA1 (or empty)
10 # $4 - pathname in repository
11 # $5 - original file mode (or empty)
12 # $6 - file in branch1 mode (or empty)
13 # $7 - file in branch2 mode (or empty)
15 # Handle some trivial cases.. The _really_ trivial cases have
16 # been handled already by git read-tree, but that one doesn't
17 # do any merges that might change the tree layout.
19 USAGE='<orig blob> <our blob> <their blob> <path>'
20 USAGE="$USAGE <orig mode> <our mode> <their mode>"
21 LONG_USAGE="usage: git merge-one-file $USAGE
23 Blob ids and modes should be empty for missing files."
25 SUBDIRECTORY_OK=Yes
26 . git-sh-setup
27 cd_to_toplevel
28 require_work_tree
30 if test $# != 7
31 then
32 echo "$LONG_USAGE"
33 exit 1
36 case "${1:-.}${2:-.}${3:-.}" in
38 # Deleted in both or deleted in one and unchanged in the other
40 "$1.." | "$1.$1" | "$1$1.")
41 if test -n "$2"
42 then
43 echo "Removing $4"
44 else
45 # read-tree checked that index matches HEAD already,
46 # so we know we do not have this path tracked.
47 # there may be an unrelated working tree file here,
48 # which we should just leave unmolested. Make sure
49 # we do not have it in the index, though.
50 exec git update-index --remove -- "$4"
52 if test -f "$4"
53 then
54 rm -f -- "$4" &&
55 rmdir -p "$(expr "z$4" : 'z\(.*\)/')" 2>/dev/null || :
56 fi &&
57 exec git update-index --remove -- "$4"
61 # Added in one.
63 ".$2.")
64 # the other side did not add and we added so there is nothing
65 # to be done, except making the path merged.
66 exec git update-index --add --cacheinfo "$6" "$2" "$4"
68 "..$3")
69 echo "Adding $4"
70 if test -f "$4"
71 then
72 echo "ERROR: untracked $4 is overwritten by the merge." >&2
73 exit 1
75 git update-index --add --cacheinfo "$7" "$3" "$4" &&
76 exec git checkout-index -u -f -- "$4"
80 # Added in both, identically (check for same permissions).
82 ".$3$2")
83 if test "$6" != "$7"
84 then
85 echo "ERROR: File $4 added identically in both branches," >&2
86 echo "ERROR: but permissions conflict $6->$7." >&2
87 exit 1
89 echo "Adding $4"
90 git update-index --add --cacheinfo "$6" "$2" "$4" &&
91 exec git checkout-index -u -f -- "$4"
95 # Modified in both, but differently.
97 "$1$2$3" | ".$2$3")
99 case ",$6,$7," in
100 *,120000,*)
101 echo "ERROR: $4: Not merging symbolic link changes." >&2
102 exit 1
104 *,160000,*)
105 echo "ERROR: $4: Not merging conflicting submodule changes." >&2
106 exit 1
108 esac
110 src1=$(git-unpack-file $2)
111 src2=$(git-unpack-file $3)
112 case "$1" in
114 echo "Added $4 in both, but differently."
115 orig=$(git-unpack-file $2)
116 create_virtual_base "$orig" "$src2"
119 echo "Auto-merging $4"
120 orig=$(git-unpack-file $1)
122 esac
124 git merge-file "$src1" "$orig" "$src2"
125 ret=$?
126 msg=
127 if test $ret != 0 || test -z "$1"
128 then
129 msg='content conflict'
130 ret=1
133 # Create the working tree file, using "our tree" version from the
134 # index, and then store the result of the merge.
135 git checkout-index -f --stage=2 -- "$4" && cat "$src1" >"$4" || exit 1
136 rm -f -- "$orig" "$src1" "$src2"
138 if test "$6" != "$7"
139 then
140 if test -n "$msg"
141 then
142 msg="$msg, "
144 msg="${msg}permissions conflict: $5->$6,$7"
145 ret=1
148 if test $ret != 0
149 then
150 echo "ERROR: $msg in $4" >&2
151 exit 1
153 exec git update-index -- "$4"
157 echo "ERROR: $4: Not handling case $1 -> $2 -> $3" >&2
159 esac
160 exit 1